Subject: Re: [PATCH net-next v2] net: phy: Fix suspicious rcu_dereference usage

From: Jakub Kicinski <[email-masked]>
Date: Fri, 17 Jan 2025 19:07:20 -0800

On Fri, 17 Jan 2025 23:16:59 +0100 Kory Maincent wrote:
> > If not protected by RTNL, what prevents two threads from calling this
> > function at the same time,
> > thus attempting to kfree_rcu() the same pointer twice ?  
> 
> I don't think this function can be called simultaneously from two threads,
> if this were the case we would have already seen several issues with the phydev
> pointer. But maybe I am wrong.
> 
> The rcu_lock here is to prevent concurrent dev->hwprov pointer modification done
> under rtnl_lock in net/ethtool/tsconfig.c.

I could also be wrong, but I don't recall being told that suspend path
can't race with anything else. So I think ravb should probably take
rtnl_lock or some such when its shutting itself down.. ?

If I'm wrong I think we should mention this is from suspend and
add Claudiu's stack trace to the commit msg.
-- 
pw-bot: cr